package org.tip.puck.partitions.workers;

import org.tip.puck.net.Individual;
import org.tip.puck.partitions.Cluster;
import org.tip.puck.partitions.Partition;

/**
 * 
 * Methods added in this classes has to be static and autonomous.
 * 
 * @author TIP
 */
public class PartitionUtils {
	/**
	 * Relationalizes a partition by defining an equivalence relation between
	 * any two vertices of the same cluster.
	 * 
	 * @see maps.Net#relationalize()
	 */
	public <E> void relationalize(final Partition<E> source) {
		for (Cluster<E> cluster : source.getClusters()) {
			if (!cluster.isNull()) {
				for (int i = 0; i < cluster.size(); i++) {
					Individual ego = (Individual) cluster.getItems().get(i);
					for (int j = 0; j < i; j++) {
						Individual alter = (Individual) cluster.getItems().get(j);
						ego.addRelation("@" + source.getLabel(), alter);
						alter.addRelation("@" + source.getLabel(), ego);
						// ego.setAttribute(new
						// Attribute("@"+attributeLabel,((Individual)alter).getId()+""));
						// alter.setAttribute(new
						// Attribute("@"+attributeLabel,((Individual)ego).getId()+""));
					}
				}
			}
		}
	}
	

}
